# Fields Changes

## 0.1.3

- Updated to Dart SDK 0.8.10_r29803.
- Added a generic type parameter `T` to `Field<T>` as a means to document the 
underlying type of a field.  The type `T` is asserted to be assignable from the 
reflected type of the underlying object in checked mode only.

## 0.1.2

- Optimization in `FieldListView` render.

## 0.1.1

- Updated to Dart SDK 0.8.7_r29341.

## 0.1.0

- Changed `ObjectEditor` from a subtype of `HasElement` to a subtype of 
`HtmlElement`.
- Added the `@RuntimeType` annotation as a workaround for Dart issues #6433 and
#12022.  This will be removed as soon as those issues are resolved, but in the
meantime it provides a means to ship working code.

## 0.0.8

- Updated to Dart SDK 0.7.6_r28108.
- Added a `SelectEditor` and `UseValues` annotation.
- Changed the `Field` and `FieldEditor` `value` accessors from asynchronous
methods that return futures to synchronous getters and setters.  The 
implementation now uses synchronous mirrors (`InstanceMirror.getField` etc...) 
to close issue #3.  This makes the API easier to use for extending `FieldEditor`
with your own custom editors.  It is also very likely that the asynchronous
mirrors API will be removed from `dart:mirrors` in the near future.
- Added a `UseFieldTransform` annotation.
- Changed the `FieldTransform` class to a concrete class that can be directly
instantiated as `const` with given `transform` and optional `inverse` functions.

## 0.0.7

- Updated to Dart SDK 0.7.3_r27487.
- Renamed the asset directory from 'lib/res/' to 'lib/asset/' in preparation for 
`pub serve`; this will move up to a top-level directory 'asset/' once `pub` is
able to serve that to the dependency graph.
- Added `Field.forGetter` and `Field.forVariable` factory constructors; these
are experimental and designed to make it easier to use `FieldEditor` instances
outside of an `ObjectEditor`.  For example, other data entry widgets such as a
data grid might want to reuse these field editors.  This is subject to change.

## 0.0.6

- Update to `tags` version 0.1.9.

## 0.0.5

- Added support for proxy objects; the fields of the `selected` object are 
reflected based on its `runtimeType`, which proxy classes may override.
- Moved all of the libraries into `lib/src/` and export the entire public API
through the `lib/fields.dart` library.  This provides a single import statement
for applications that use this package.

## 0.0.4

- Cleaned up the `FieldEditor` and `Transform` registration interfaces.
- Gave more specific names to the `Resources` classes.
- Added the `bench` package to `dev_dependencies` to run the unit tests.
- Updated to Dart SDK 0.6.13_r25630.

## 0.0.3

- Updated to `tags` version `0.1.4`.
- Changed the image links in the README.md to absolute links as Pub does not
recognize Github relative links: https://github.com/dart-lang/py-gfm/issues/8

## 0.0.2

- More early work.

## 0.0.1

- Initial version.
