library fields.model;

import 'dart:async';
import 'dart:collection';
import 'dart:mirrors';
import 'theme.dart';

part 'model/field.dart';
part 'model/field_editor.dart';
part 'model/field_list.dart';
part 'model/field_transform.dart';
part 'model/meta.dart';
part 'model/mirrors.dart';

void registerDefaultFieldTransforms() {  
  FieldTransform.register(const FieldTransform<int, num>(_int2num));
  FieldTransform.register(const FieldTransform<num, int>(_num2int));
  FieldTransform.register(const FieldTransform<String, int>(_string2int));
  FieldTransform.register(const FieldTransform<String, double>(_string2double));
}
