library fields.theme;

FieldsTheme _theme = const FieldsTheme(); 
FieldsTheme 
  get fieldsTheme => _theme;
  set fieldsTheme(FieldsTheme theme) => _theme = theme;

// -----------------------------------------------------------------------------
// Default
// -----------------------------------------------------------------------------

const _assetDir = 'packages/fields/asset/';
  
class FieldsTheme {
  final FieldsColors colors = const FieldsColors();
  final FieldsImages images = const FieldsImages();
  const FieldsTheme();
}
  
class FieldsColors {
  final String background = 'transparent';
  final String border = 'grey';
  final String error = 'red';
  final String fieldBackground = 'transparent';
  final String text = 'black';
  final String textDisabled = 'grey';
  const FieldsColors();
}

class FieldsImages {
  final String down = '${_assetDir}down.png';
  final String up = '${_assetDir}up.png';
  final String lock = '${_assetDir}lock.png';  
  final String unlock = '${_assetDir}/unlock.png';
  const FieldsImages();
}

// -----------------------------------------------------------------------------
// Dark
// -----------------------------------------------------------------------------

const _assetDarkDir = '${_assetDir}dark/';

class DarkFieldsTheme extends FieldsTheme {
  final FieldsColors colors = const DarkFieldsColors();
  final FieldsImages images = const DarkFieldsImages();
  const DarkFieldsTheme();
}

class DarkFieldsColors extends FieldsColors {
  final String background = '#2d2d30';
  final String border = '#2d2d30';
  final String fieldBackground = '#252526';
  final String text = '#f1f1f1';
  const DarkFieldsColors();
}

class DarkFieldsImages extends FieldsImages {
  final String down = '${_assetDarkDir}down.png';
  final String up = '${_assetDarkDir}up.png';
  final String lock = '${_assetDarkDir}lock.png';  
  final String unlock = '${_assetDarkDir}unlock.png';
  const DarkFieldsImages();
}
